﻿$(document).ready(() => {
    function InitColorPickers() {
        $('#FirstChartColor').colorpicker();
        $('#SecondChartColor').colorpicker();
    }

    function ShowColorPickersSection() {
        if ($('#RandomChartColors').prop('checked')) {
            $('#ColorPickersSection').hide();
        }
        else {
            $('#ColorPickersSection').show();
        }
    }

    function ShowCorrectSection() {
        if ($('#NodeID').val() * 1 > 0) {//node
            $('#NodeSection').show();
            $('#DeviceSection').hide();
            $('#DepartmentSection').hide();
            $('#SubscriberSection').hide();

            $('#StatisticFor').val(0);
        }
        else if ($('#DeviceID').val() * 1 > 0) {//pbx
            $('#NodeSection').hide();
            $('#DeviceSection').show();
            $('#DepartmentSection').hide();
            $('#SubscriberSection').hide();

            $('#StatisticFor').val(1);
        }
        else if ($('#DepartmentID').val() * 1 > 0) {//department
            $('#NodeSection').hide();
            $('#DeviceSection').hide();
            $('#DepartmentSection').show();
            $('#SubscriberSection').hide();

            $('#StatisticFor').val(2);
        }
        else if ($('#AbonentID').val() * 1 > 0) {//abonent
            $('#NodeSection').hide();
            $('#DeviceSection').hide();
            $('#DepartmentSection').hide();
            $('#SubscriberSection').show();

            $('#StatisticFor').val(3);
        }
        else {//default node
            $('#NodeSection').show();
            $('#DeviceSection').hide();
            $('#DepartmentSection').hide();
            $('#SubscriberSection').hide();

            $('#StatisticFor').val(0);
        }
    }

    function AllDirectionsSet() {
        if ($('#AllDirections').prop('checked')) {
            $('#DirectionsSections').addClass('disDiv');
        }
        else {
            $('#DirectionsSections').removeClass('disDiv');
        }
    }

    function ShowCorrectCompare() {
        if ($('#AddCompare').prop('checked')) {

            switch ($('#StatisticFor').val() * 1) {
                case 0://node
                default:
                    $('#NodeIDLabel').show();
                    $('#PBXIDLabel').hide();
                    $('#DepartmentIDLabel').hide();
                    $('#SubscriberIDLabel').hide();
                    break;
                case 1://pbx
                    $('#NodeIDLabel').hide();
                    $('#PBXIDLabel').show();
                    $('#DepartmentIDLabel').hide();
                    $('#SubscriberIDLabel').hide();
                    break;
                case 2://department
                    $('#NodeIDLabel').hide();
                    $('#PBXIDLabel').hide();
                    $('#DepartmentIDLabel').show();
                    $('#SubscriberIDLabel').hide();
                    break;
                case 3:
                    $('#NodeIDLabel').hide();
                    $('#PBXIDLabel').hide();
                    $('#DepartmentIDLabel').hide();
                    $('#SubscriberIDLabel').show();
                    break;
            }

            $('#CompareSection').slideDown('fast');
        }
        else {
            $('#CompareSection').slideUp('fast');
            $('#CompareID').val(-1);
        }
    }

    function SetCompareCheckBox() {
        $('#AddCompare').prop('checked', $('#CompareID').val() * 1 > 0);
    }

    //open selection section
    $('#StatisticFor').change(() => {
        switch ($('#StatisticFor').val() * 1) {
            case 0://node
            default:
                $('#NodeSection').show();
                $('#DeviceSection').hide();
                $('#DepartmentSection').hide();
                $('#SubscriberSection').hide();

                $('#DeviceID').val(-1);
                $('#DepartmentID').val(-1);
                $('#AbonentID').val(-1);
                break;
            case 1://pbx
                $('#NodeSection').hide();
                $('#DeviceSection').show();
                $('#DepartmentSection').hide();
                $('#SubscriberSection').hide();

                $('#NodeID').val(-1);
                $('#DepartmentID').val(-1);
                $('#AbonentID').val(-1);
                break;
            case 2://department
                $('#NodeSection').hide();
                $('#DeviceSection').hide();
                $('#DepartmentSection').show();
                $('#SubscriberSection').hide();

                $('#NodeID').val(-1);
                $('#DeviceID').val(-1);
                $('#AbonentID').val(-1);
                break;
            case 3://subscriber
                $('#NodeSection').hide();
                $('#DeviceSection').hide();
                $('#DepartmentSection').hide();
                $('#SubscriberSection').show();

                $('#NodeID').val(-1);
                $('#DeviceID').val(-1);
                $('#DepartmentID').val(-1)
                break;
        }

        ShowCorrectCompare();
    });

    //set direction section
    $('#AllDirections').change(AllDirectionsSet);

    //set compare section
    $('#AddCompare').change(ShowCorrectCompare);

    //show/hide color pickers
    $('#RandomChartColors').change(ShowColorPickersSection);

    ShowCorrectSection();
    AllDirectionsSet();
    SetCompareCheckBox();
    ShowCorrectCompare();
    InitColorPickers();
    ShowColorPickersSection();
});